;=======================================;
;Title: DBZ III: Killer Androids 	;
;Substring Loading	    		;
;=======================================;
;Loads substrings, when they're not used;
;as substrings. This is the code	;
;byte-for-byte that appears in the	;
;original and hacked rom.		;
;					;
;Why did I retype it? I have no idea.	;
;=======================================;

.org $d776
.mem 8
.index 8

get_ptr:
	jsr $dc82			;Retrieve pointer. Store it at $a5-$a6.

	ldx $0578			;Get current place in ram buffer to write to.
	ldy #$00			;Start at the first byte.

store_y:
	sty $05f9			;Store length of string in the temp_buffer.

read_byte:
	lda ($a5),y			;Read byte.
	beq check_a7			;$00 == EOS

	jsr $f940			;Check for dakuten/handakuten and store the top tile.

	ldy $05f9			;Restore Y and store the bottom tile in the temp_buffer.
	sta $05fa,y
	inx
	iny

	cpy #$0d			;12 characters max.
	bcc store_y			;If not done, store the length and read another byte.
	beq loc_d7b0

check_a7:
	lda #$0d			;Check to see if the max length has been met.
	cmp $a7
	bcs loc_d79e			;If length has been exceeded, determine if buffer needs to
					;be padded.

	sta $a7				;If not, pad it.

loc_d79e:
	cpy $a7
	bcs loc_d7b0

	lda #$01

pad:
	sta $057d,x			;Pad buffers with blank tiles.
	sta $05fa,y

	inx
	iny

	cpy				;Repeat until the entire buffer has been padded ($0d bytes).
	bcc pad

loc_d7b0:
	ldx $0578
	tya				;Make sure there's something that needs to go to vram.
	beq end

loc_d7b6:
	sta $05f9			;Length of temp_buffer.

	jsr $cc9d			;Update to-write buffer. Sets vram address and mirroring for this chunk
					;of data.

	lda $a3				;Next string will be written on the line below the current one.
	clc
	adc #$20
	sta $a3
	bcc loc_d7c7

	inc $a4				;If a carry occured, account for it by incrementing the high byte.

loc_d7c7:
	ldx $0578
	tya
	jsr $cc9d			;Update the buffer for the data in the temp_buffer.

	ldy #$00

copy_buffer:
	lda $05fa,y			;Read temp_buffer (contains bottom tiles)
	sta $057d,x			;and store it in the to-write buffer.

	inx
	iny

	cpy $05f9			;Check length of temp_buffer.
	bcc copy_buffer

end:
	rts